/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function ObmGlobalData() {
  //Init logger
  this.logger = Cc["@obm.org/calendar/logger;1"].createInstance(Ci.obmILogger);
  var writer = Cc["@obm.org/calendar/writer;1?type=unixfile"].getService(Ci.obmILoggerWriter);
  this.logger.setLevelWriter(this.logger.LOAD_LEVEL, writer);
  this.logger.setHeader("ObmGlobalData: ");
  this.logger.debug("new ObmGlobalData()", false, false);

	this.wrappedJSObject = this;
};

ObmGlobalData.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
	mPassword: null,
	get password() {
		return this.mPassword;
	},
	set password(password) {
		return (this.mPassword = password);
	},
	mCanceled: false,
	get canceled() {
		return this.mCanceled;
	},
	set canceled(canceled) {
		return (this.mCanceled = canceled);
	},
	mAddrSynchronizing: false,
	get addrSynchronizing() {
		return this.mAddrSynchronizing;
	},
	set addrSynchronizing(addrSynchronizing) {
		return (this.mAddrSynchronizing = addrSynchronizing);
	}
};

var ObmGlobalDataModule = {
	mCID: Components.ID("{f98dec88-c790-4f69-8f89-cb0fb4edd1a2}"),
	mContractID: "@obm.org/globaldata;1",
	registerSelf: function (compMgr, fileSpec, location, type) {
		compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(
			this.mCID,
			"OBM Global Data",
			this.mContractID,
			fileSpec,
			location,
			type
		);
	},
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.mCID)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		if (!iid.equals(Ci.nsIFactory)) {
			throw Cr.NS_ERROR_NOT_IMPLEMENTED;
		}
		return this.mFactory;
	},
	mFactory: {
		createInstance: function (outer, iid) {
			if (outer != null) {
				throw Cr.NS_ERROR_NO_AGGREGATION;
			}
			return (new ObmGlobalData()).QueryInterface(iid);
		}
	},

	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {
	return ObmGlobalDataModule;
}