/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function UnixFileWriter () {
	if (!this._file) {
    try {
		var fileName = 'obm-connector-log.txt';
		try {
			var prefBranch = Components.classes["@mozilla.org/preferences-service;1"]
										.getService(Components.interfaces.nsIPrefBranch);

			fileName = prefBranch.getCharPref("extensions.obm.log.file");
			if (fileName == '')
				fileName = 'obm-connector-log.txt';
		} catch (e) {
			fileName = 'obm-connector-log.txt';
		}

    	//TODO "TmpD -> ProfD"
      var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("TmpD", Ci.nsIFile);
      file.append(fileName);
      this._file = file;
      this._stream = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);

      //	see: http://mxr.mozilla.org/mozilla/source/nsprpub/pr/include/prio.h
      //	PR_WRONLY		0x02
      //	PR_CREATE_FILE	0x08
      //	PR_APPEND 0x10 	
      this._stream.init(this._file, 0x02 | 0x08 | 0x10 , 0666, 0); 


      var hello = "New session: " + Date() + "\n";
      this._stream.write(hello, hello.length);
      this._stream.flush();
    } catch(e) {}
	} else {
		dump("ERROOOOOR !!!\n");
	}
};

/* instance methods */
UnixFileWriter.prototype.init = function (obj) { };
UnixFileWriter.prototype.write = function (msg, level) {
  /* Color
	var color;
	switch (level) {
		case Ci.obmILogger.DEBUG_LEVEL:
		color = "\033[34;1m";
		break;
		case Ci.obmILogger.NOTICE_LEVEL:
		color = "\033[32;1m";
		break;
		case Ci.obmILogger.WARNING_LEVEL:
		color = "\033[33;1m";
		break;
		case Ci.obmILogger.ERROR_LEVEL:
		color = "\033[31;1m";
		break;
		default:
		color = "";
	}
	msg = color + msg + "\033[m";
  */
  if (this._stream) {
  	this._stream.write(msg, msg.length);
	  this._stream.flush();
  }
};

UnixFileWriter.prototype.QueryInterface = function(aIID)  {
	if (!aIID.equals(Ci.nsISupports) &&
	!aIID.equals(Ci.obmILoggerWriter)) {
		throw Cr.NS_ERROR_NO_INTERFACE;
	}
	return this;
};

// module

var UnixFileWriterModule = {
	mCID: Components.ID("{d2e49656-9ccd-4e4e-82a7-24c987af14a8}"),
	mContractID: "@obm.org/calendar/writer;1?type=unixfile",
	registerSelf: function (compMgr, fileSpec, location, type) {
		compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(
			this.mCID,
			"OBM Logger Writter: UnixFile",
			this.mContractID,
			fileSpec,
			location,
			type
		);
	},
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.mCID)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		if (!iid.equals(Ci.nsIFactory)) {
			throw Cr.NS_ERROR_NOT_IMPLEMENTED;
		}
		return this.mFactory;
	},
	mFactory: {
		createInstance: function (outer, iid) {
			if (outer != null) {
				throw Cr.NS_ERROR_NO_AGGREGATION;
			}
			return (new UnixFileWriter()).QueryInterface(iid);
		}
	},

	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {
	return UnixFileWriterModule;
}

