/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
/*
 * Globals
 */

var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
.createInstance(Components.interfaces.mozIJSSubScriptLoader);

var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
.getService(Components.interfaces.nsIPromptService);
function log(e) {
	Components.utils.reportError(e);// UtilsOBM.logMessageToConsole(e);
}

/*
 * Scritps
 */
if ( typeof(UtilsOBM) == "undefined" ) {
	scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/UtilsOBM.js");
}

if ( typeof(calendarDefaultTimezone) == "undefined" ) {
	try {
		scriptLoader.loadSubScript("chrome://calendar/content/calUtils.js");
	} catch(e) {}
}

// Init logger
var gLogger = Components.classes["@obm.org/calendar/logger;1"].createInstance(Components.interfaces.obmILogger);
var writer = Components.classes["@obm.org/calendar/writer;1?type=unixfile"].getService(Components.interfaces.obmILoggerWriter);
gLogger.setLevelWriter(gLogger.LOAD_LEVEL, writer);
gLogger.setHeader("=== extension.js: ");


/*
 * Functions
 */
function OBM_ShowWindow(aName) {
	//var retValues = { cancel:false };
	window.openDialog(
		"chrome://obm-extension/content/calendar/" + aName,  "",
		"modal,centerscreen,chrome,resizable=no"
		//, retValues
	);
	var globalData = Components.classes["@obm.org/globaldata;1"].getService().wrappedJSObject;
	//return !retValues.cancel && !globalData.cancel;
	return !globalData.cancel;
}

function OBM_ShowLog() {

	var fileName = UtilsOBM.getCharPref("extensions.obm.log.file");
	if (fileName == '')
		fileName = 'obm-connector-log.txt';

  var file = Components.classes["@mozilla.org/file/directory_service;1"].
    getService(Components.interfaces.nsIProperties).
    get("TmpD", Components.interfaces.nsIFile);
  file.QueryInterface(Components.interfaces.nsILocalFile);
  file.append(fileName);
  try {
    file.launch();
  } catch(e) {
    try {
      var uri = Components.classes["@mozilla.org/network/io-service;1"].
        getService(Components.interfaces.nsIIOService).
        newFileURI(file);
      var protocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].
        getService(Components.interfaces.nsIExternalProtocolService);
      protocolSvc.loadUrl(uri);
    } catch(e) {
      alert(e);
    }
  }
}

function OBM_getTicket(){
	var obmUrl = UtilsOBM.getCharPref("extensions.obm.obmUrl");
	var dealerUrl = obmUrl + "/sso/sso_index.php?action=ticket&mode=interactive";
	var httpRequest = XMLHttpRequest();
	
	var username = {};
	var password = {};
	if ( !UtilsOBM.getOBMCredentials(username, password) || username.value == "" || password.value == "" ) {
		if (username.value == undefined || username.value == "") {
			var title = UtilsOBM.getLocalizedMessage("obmconf");
			var message = UtilsOBM.getLocalizedMessage("obmconfcredentials");
			promptService.alert(window, title, message);

			if (OBM_ShowWindow("preferences/connection.xul"))
				return OBM_getTicket();
			else
				return null;
		} else {
			// prompt only for password
			if (!OBM_ShowWindow("preferences/password.xul"))
				return null;
			if (UtilsOBM.getTemporaryPassword(password) == false) {
				return null//;OBM_getTicket();
			}
		}
	}

	httpRequest.open('POST', dealerUrl, false);
	httpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	try {
		var params = "login=" + encodeURIComponent( username.value )
		+ "&password=" + encodeURIComponent( password.value );
		//dump("params:"+params+"\n");
		httpRequest.send(params);
	} catch (e) {
		throw e;
	}
	var httpResponse = {
		status: httpRequest.status,
		statusText: httpRequest.statusText,
		responseXML: httpRequest.responseText
	};
	//dump("resp:"+httpResponse.responseXML+"\n");
	if (!httpResponse.responseXML.match("ticket=[:print:]*")) {
		throw new Error('noTicket');
	}
	return httpResponse.responseXML;
}

function OBM_OpenLink(aPage) {
	// suppress external-load warning for standard browser schemes
	UtilsOBM.setBoolPref("network.protocol-handler.warn-external.http", false);
	UtilsOBM.setBoolPref("network.protocol-handler.warn-external.https", false);

	var obmUrl = UtilsOBM.getCharPref("extensions.obm.obmUrl", "");
	if (obmUrl == "") {
		var title = UtilsOBM.getLocalizedMessage("obmconf");
		var message = UtilsOBM.getLocalizedMessage("obmconfobmweb");
		promptService.alert(window, title, message);
		if (OBM_ShowWindow("preferences/connection.xul"))
			return OBM_OpenLink(aPage);
		else
			return null;
	}
	var sso = UtilsOBM.getBoolPref("extensions.obm.sso", false);
	var pageURL = obmUrl;
	if (sso) {
		try {
			var ticket = OBM_getTicket();
		} catch (e) {
			if (e.message == 'noTicket') {
				UtilsOBM.showAlert("authenticationfailed");
			} else {
				UtilsOBM.showAlert("connectionfailed");
			}
			return null;
		}
		if (!ticket) {
			return null;
		}
	}
	switch (aPage) {
		case "obm-web-agenda":
				pageURL += "/calendar/calendar_index.php?action=waiting_events&auth_ticket=" + ticket.split("=")[1];     
				break;
		case "obm-web-account":
				pageURL += "?auth_ticket=" + ticket.split("=")[1];
				break;
		default:
				return null;
	}
	var ioservice = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var uriToOpen = ioservice.newURI(pageURL, null, null);
	var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
	// now, open it!
	extps.loadURI(uriToOpen, null);
	return null;
}

function OBM_Synchronize() {
	
	try {
		var globalData = Components.classes["@obm.org/globaldata;1"].getService().wrappedJSObject;
		var username = {};
		var password = {};
		if ( !UtilsOBM.getOBMCredentials(username, password)
		|| username.value == "" || password.value == ""
		|| UtilsOBM.getCharPref("extensions.obm.server", "") == "" ) {
			if (username.value == undefined || username.value == ""
			|| UtilsOBM.getCharPref("extensions.obm.server", "") == "") {
				var title = UtilsOBM.getLocalizedMessage("obmconf");
				var message = UtilsOBM.getLocalizedMessage("obmconfsyncserver");
				promptService.alert(window, title, message);

				if (!OBM_ShowWindow("preferences/connection.xul"))
					return null;
				return OBM_Synchronize();
			} else {
				// prompt only for password
				if (!OBM_ShowWindow("preferences/password.xul"))
					return null;
				if (UtilsOBM.getTemporaryPassword(password) == false)
					return OBM_Synchronize();
			}
		}
		
		var wWatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);

		var params = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
		/*
		 * var description =
		 * Components.classes["@mozilla.org/supports-string;1"]
		 * .createInstance(Components.interfaces.nsISupportsString);
		 * description.data = "Agenda \"" + this.name + "\"";
		 * params.AppendElement(description); params.AppendElement(this);
		 */
		var window = wWatcher.getWindowByName("OBM_SYNCHRO", null)
		if (window == null){
			UtilsOBM.logToFile("synchronization window does not exist" + "\n");

			window = wWatcher.openWindow(
				null,
				"chrome://obm-extension/content/calendar/sync-dialog.xul",
				"OBM_SYNCHRO",
				"modal,centerscreen,chrome,resizable=no,dialog",
				params
			);

		} else {
			UtilsOBM.logToFile("synchronization window already exist" + "\n");
		}
	} catch (e) {
		gLogger.error(e, true, false);
	}
	return null;
}

/* Connection Window */

function OBM_LoadConnectionSettings() {
	document.getElementById("syncLocation").value = UtilsOBM.getCharPref("extensions.obm.server", "");
	document.getElementById("webLocation").value = UtilsOBM.getCharPref("extensions.obm.obmUrl", "");
	var username = {};
	var password = {};
	if ( UtilsOBM.getOBMCredentials(username, password) ) {
		document.getElementById("username").value = username.value;
		document.getElementById("password").value = password.value;
	}
	document.getElementById("savepassword").checked = UtilsOBM.getBoolPref("extensions.obm.rememberpassword", true);
}
function OBM_LoadPasswordSettings() {
	var username = {};
	var password = {};
	if ( UtilsOBM.getOBMCredentials(username, password) ) {
		document.getElementById("password").value = password.value;
	}
	document.getElementById("savepassword").checked = UtilsOBM.getBoolPref("extensions.obm.rememberpassword", true);
}

function OBM_SaveConnectionSettings(cancel) {
	try {
		var globalData = Components.classes["@obm.org/globaldata;1"].getService().wrappedJSObject;
		if (cancel) {
			globalData.cancel = true;
			return;
		} else {
			globalData.cancel = false;
		}
		
		UtilsOBM.setCharPref("extensions.obm.server", document.getElementById("syncLocation").value);
		UtilsOBM.setCharPref("extensions.obm.obmUrl", document.getElementById("webLocation").value);
	
		UtilsOBM.setBoolPref("extensions.obm.rememberpassword",
		document.getElementById("savepassword").checked);
		if (document.getElementById("savepassword").checked){
			UtilsOBM.setOBMCredentials(document.getElementById("username").value,
			document.getElementById("password").value);
		} else {
			UtilsOBM.setOBMCredentials(document.getElementById("username").value, "");
			UtilsOBM.setTemporaryPassword(document.getElementById("password").value);
		}
	} catch (e) {
		gLogger.error(e,true,false);
	}
}

function OBM_SavePasswordSettings(cancel) {
	var globalData = Components.classes["@obm.org/globaldata;1"].getService().wrappedJSObject;
	if (cancel) {
		globalData.cancel = true;
		return;
	} else {
		globalData.cancel = false;
	}
	UtilsOBM.setBoolPref("extensions.obm.rememberpassword",
		document.getElementById("savepassword").checked);
	if (document.getElementById("savepassword").checked){
		var username = {};
		var password = {};
		if (UtilsOBM.getOBMCredentials(username, password)){    
			UtilsOBM.setOBMCredentials(username.value,
			document.getElementById("password").value);
		} else {
			UtilsOBM.setTemporaryPassword(document.getElementById("password").value);
		}
	} else {
		UtilsOBM.setTemporaryPassword(document.getElementById("password").value);
	}
}

/* Synchronization Window */

function OBM_LoadSynchronizationSettings() {
  document.getElementById("override").value = UtilsOBM.getCharPref("extensions.obm.override", "");
  document.getElementById("contactRefresh").value = UtilsOBM.getIntPref("extensions.obm.contact.autorefresh.timeout", "");
  if (UtilsOBM.getBoolPref("calendar.autorefresh.enabled", false)) {
    document.getElementById("calendarRefresh").value = UtilsOBM.getIntPref("calendar.autorefresh.timeout", "");
  } else {
    document.getElementById("calendarRefresh").value = "";
  }
  document.getElementById("calendarRefresh").value = UtilsOBM.getIntPref("calendar.autorefresh.timeout", "");
  document.getElementById("syncOnStart").checked = UtilsOBM.getBoolPref("extensions.obm.syncOnStart", false);
  document.getElementById("syncOnQuit").checked = UtilsOBM.getBoolPref("extensions.obm.syncOnQuit", false);
}

function OBM_SaveSynchronizationSettings() {
  UtilsOBM.setCharPref("extensions.obm.override", document.getElementById("override").value);
  UtilsOBM.setIntPref("extensions.obm.contact.autorefresh.timeout", document.getElementById("contactRefresh").value);
  var crefresh = document.getElementById("calendarRefresh").value;
  UtilsOBM.setIntPref("calendar.autorefresh.timeout", crefresh);
  if (crefresh == "" || crefresh == 0) {
    UtilsOBM.setBoolPref("calendar.autorefresh.enabled",false);
  } else {
    UtilsOBM.setBoolPref("calendar.autorefresh.enabled",true);
  }
  UtilsOBM.setBoolPref("extensions.obm.syncOnStart", document.getElementById("syncOnStart").checked);
  UtilsOBM.setBoolPref("extensions.obm.syncOnQuit", document.getElementById("syncOnQuit").checked);
}

// DEPRECATED. OBM_NEW_AD_MANAGER. use obmIAddressBooksManager::getAddressBookUids instead
function OBM_GetAddressBookNames() {
  var names = UtilsOBM.getCharPref("extensions.obm.addressbooks", null);
  return names ? names.split(",") : [];
}

/* Reset Button */
function OBM_Reset() {
	UtilsOBM.reset();
}

function OBM_ImportCalendars() {
	var calendarManager = UtilsOBM.getCalendarManager();

	var calendars = calendarManager.getCalendars({});
	for each ( var calendar in calendars ) {
		if ( calendar.type == "obm" ) {
			UtilsOBM.importCalendar(calendar);
		}
	}
}

function OBM_Purge() {
	var preff = UtilsOBM.getBoolPref("extensions.obm.calEvents.is_sync_enabled", true);
	if (preff) {
	  //ask for purge on personnal calendar
	  var username = {};
	  var password = {};
	  if (!UtilsOBM.getOBMCredentials(username, password) || username.value == "") {
		//nothing
	  } else {
		var calendarManager = UtilsOBM.getCalendarManager();
		var calendars = calendarManager.getCalendars({});
		for each(var calendar in calendars) {
		  if (calendar.type == "obm") {
			var calName = calendarManager.getCalendarPref_(calendar, "X-OBM-NAME");
			if (calName == username.value.split("@")[0]) {
			  UtilsOBM.purgeCalendar(calendar);
			  break;
			}
		  }
		}
	  }
	}
}


function OBM_UpdateNotificationPreference(selectedItem) {
  function log(msg) {
      Components.classes["@mozilla.org/consoleservice;1"]
      .getService(Components.interfaces.nsIConsoleService).logStringMessage(msg);;
   };
  if ( selectedItem === null ) {
    log("obmPrefs: no item selected");
  } else {
    log("obmPrefs: item seelcted: "+selectedItem.value);
    UtilsOBM.setCharPref("extensions.obm.sendNotifications", selectedItem.value);
  }
}
