/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
// Init logger
var lLogger = Components.classes["@obm.org/calendar/logger;1"].createInstance(Components.interfaces.obmILogger);
var lwriter = Components.classes["@obm.org/calendar/writer;1?type=unixfile"].getService(Components.interfaces.obmILoggerWriter);
lLogger.setLevelWriter(gLogger.LOAD_LEVEL, lwriter);
lLogger.setHeader("=== lightningOverlay: ");

var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].createInstance(Components.interfaces.mozIJSSubScriptLoader);

if (typeof(UtilsOBM) == "undefined") {
  scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/UtilsOBM.js");
}

function ensureOBMCalendarsArePresent() {
  var calMgr = Components.classes["@mozilla.org/calendar/manager;1"].getService(Components.interfaces.calICalendarManager);
  var calendars = calMgr.getCalendars({});
  for each(var calendar in calendars) {
	if (calendar.type == "obm") return true;
  }
  return false;
}

// DEPRECATED TODO. NEW_OBM_CALENDAR_MANAGER. use obmICalendarsManager::subscribeObmCalendar() instead
function subscribeToOBMCalendar(aCalInfo) {
  var uid = aCalInfo.uid;
  var name = UtilsOBM.getCharPref("extensions.obm.autoconf.calname", null);
  if (!name) {
	name = "[OBM] " + uid;
  }
  var email = aCalInfo.mail;
  var color = UtilsOBM.getRandomColor();
  var readonly = !aCalInfo.write;
  dump("_subscribeTo: " + uid + ", " + name + ", " + email + ", " + color + ", " + readonly + "\n");

  var calMgr = Components.classes["@mozilla.org/calendar/manager;1"].getService(Components.interfaces.calICalendarManager);
  UtilsOBM.setBoolPref("extensions.obm.changes.calICalendar." + uid + ".readOnly", readonly);

  var uri = Components.classes["@mozilla.org/network/simple-uri;1"].createInstance(Components.interfaces.nsIURI);
  uri.spec = "moz-profile-calendar://?id=" + UtilsOBM.getNextLocalCalendarID() + ";" + uid;
  var newCalendar = calMgr.createCalendar("obm", uri);
  calMgr.registerCalendar(newCalendar);
  newCalendar.name = name;
  calMgr.setCalendarPref_(newCalendar, "X-OBM-NAME", uid.toString());
  calMgr.setCalendarPref_(newCalendar, 'X-OBM-EMAIL', email.toString());
  newCalendar.setProperty("color", color.toString());

  UtilsOBM.setCharPref("extensions.obm.changes." + Components.interfaces.calICalendar + "." + uid + "." + "lastSync", "1970-01-01T00:00:00Z");

  return newCalendar;
}

// Thunderbird
if (Components.interfaces.calICalendar) {
  lLogger.debug("subscribeToOBMCalendar: Setting pref calendar.itip.notify=false", false, false);
  UtilsOBM.setBoolPref("calendar.itip.notify", false);
  
  // autoconf : subscribe to calendar and remove lightning default calendar
  var autoconfedLogin = UtilsOBM.getCharPref("extensions.obm.autoconf.login", null);
  var autoconfedEmail = UtilsOBM.getCharPref("extensions.obm.autoconf.email", null);
  var autoconfRemoveDefaultCalendar = UtilsOBM.getBoolPref("extensions.obm.autoconf.removedefaultcalendar", false);
  if (autoconfedLogin) {
	if (!UtilsOBM.getOBMCredentials({},
	{})) {
	  UtilsOBM.setOBMCredentials(autoconfedLogin, "");
	  lLogger.debug("login intialized with autconfed login " + autconfedlogin, false, false);
	}

	if (autoconfedEmail) {
	  if (!ensureOBMCalendarsArePresent()) {
		var calInfo = {};
		calInfo.read = true;
		calInfo.write = true;
		calInfo.uid = autoconfedLogin.split("@")[0];
		calInfo.mail = autoconfedEmail;

		//TODO. NEW_OBM_CALENDAR_MANAGER. use obmICalendarsManager::subscribeObmCalendar() instead
		var calendar = subscribeToOBMCalendar(calInfo);

		// select in composite
		UtilsOBM.getCalendarManager().setCalendarPref_(calendar, "calendar-main-in-composite", true);
		var compositeCalendar = Components.classes["@mozilla.org/calendar/calendar;1?type=composite"].createInstance(Components.interfaces.calICompositeCalendar);
		compositeCalendar.prefPrefix = "lightning-main";
		compositeCalendar.addCalendar(calendar);
		compositeCalendar.defaultCalendar = calendar;
		lLogger.debug("calendar subscribed with autoconfed email " + autoconfedEmail, false, false);
	  }
	}

  }
  if (autoconfRemoveDefaultCalendar) {
	// supprimer au démarrage l'agenda local si présent
	var calendarManager = UtilsOBM.getCalendarManager();
	var calendars = calendarManager.getCalendars({});
	for each(var calendar in calendars) {
	  if (calendar.uri.spec == "moz-profile-calendar://") {
		calendarManager.unregisterCalendar(calendar);
		calendarManager.deleteCalendar(calendar);
		lLogger.debug("default calendar removed by autoconf", false, false);
	  }
	}
  }

}

var infos = UtilsOBM.detectVersion();

//add buttons
var lightningButtonAdded = false;

window.addEventListener("load", OBM_InitToolbar, false);

function OBM_InitToolbar() {
  lightningButtonAdded = UtilsOBM.addToolbarButton("mail:3pane", "calendar-toolbar", "chrome://messenger/content/messenger.xul#calendar-toolbar", ["lightning-obm-sync-button", "lightning-obm-web-button", "lightning-obm-account-button"], "calendar-remote-reload-button", true);
  
  var preff = UtilsOBM.getBoolPref("extensions.obm.calEvents.is_sync_enabled", true);
  if (!preff) {
		return;
  }
  //ask for purge on personnal calendar
  var username = {};
  var password = {};
  if (!UtilsOBM.getOBMCredentials(username, password) || username.value == "") {
		return;
  }
  var calendarManager = UtilsOBM.getCalendarManager();
  var calendars = calendarManager.getCalendars({});
  for each(var calendar in calendars) {
		if (calendar.type == "obm") {
			var calName = calendarManager.getCalendarPref_(calendar, "X-OBM-NAME");
			if (calName == username.value.split("@")[0]) {
				var lastPurgeAsk = UtilsOBM.getCharPref("extensions.obm.lastPurgeAsk",0);
				if (lastPurgeAsk != 0) {
					lastPurgeAsk = jsDateToDateTime(UtilsOBM.restDateToJSDate(lastPurgeAsk), calendarDefaultTimezone());
					var ellapsed = now().subtractDate(lastPurgeAsk);
					lLogger.debug(ellapsed.days + " days ellapsed since last purge ask", false, false);
					if (ellapsed.days >= 15) {
						lLogger.notice(ellapsed.days + " days ellapsed since last purge ask : Ask for Purge.", false, false);
						UtilsOBM.setCharPref("extensions.obm.lastPurgeAsk", UtilsOBM.jsDateToRestDate(now().jsDate));
						UtilsOBM.purgeCalendar(calendar);
					}
				} else {
					//init purge timer
					UtilsOBM.setCharPref("extensions.obm.lastPurgeAsk", UtilsOBM.jsDateToRestDate(now().jsDate));
				}	
				break;
			}
		}
  }
}