/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
// Init logger
var mLogger = Components.classes["@obm.org/calendar/logger;1"].createInstance(Components.interfaces.obmILogger);
var mWriter = Components.classes["@obm.org/calendar/writer;1?type=unixfile"].getService(Components.interfaces.obmILoggerWriter);
mLogger.setLevelWriter(gLogger.LOAD_LEVEL, mWriter);
mLogger.setHeader("=== mainOverlay: ");

var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].createInstance(Components.interfaces.mozIJSSubScriptLoader);
if (typeof(UtilsOBM) == "undefined") {
	scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/UtilsOBM.js");
}
if (typeof(OBM_Synchronize) == "undefined") {
	scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/extension.js");
}
if (UtilsOBM.isLightningInstalledAndEnabled() && typeof(Calendar_Event_Synchronizer) == "undefined") {
	scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/synchronizer/Calendar_Event_Synchronizer.js");
}
if (typeof(AddressBook_Contact_Synchronizer) == "undefined") {
	scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/synchronizer/AddressBook_Contact_Synchronizer.js");
}

function OBM_RegisterCalendarManagerObserver() {
	var calendarManagerObserver = {
		/* calICalendarManagerObserver interface */

		// called after the calendar is registered
		// void onCalendarRegistered(in calICalendar aCalendar);
		onCalendarRegistered: function(aCalendar) {},

		// called before the unregister actually takes place
		// void onCalendarUnregistering(in calICalendar aCalendar);
		onCalendarUnregistering: function(aCalendar) {
			mLogger.debug("onCalendarUnregistering", false, false);
			// the calendar name is still accessible, no more in onCalendarDeleting()
			if (aCalendar.type == "obm") {
				var calendarSynchronizer = new Calendar_Base_Synchronizer();
				calendarSynchronizer.notifyContainerDeleted(aCalendar);
			}
		},

		// called before the delete actually takes place
		// void onCalendarDeleting(in calICalendar aCalendar);
		onCalendarDeleting: function(aCalendar) {
			mLogger.debug("onCalendarDeleting", false, false);
			if (aCalendar.type == "obm") {
				aCalendar.QueryInterface(Components.interfaces.calICalendarProvider).deleteCalendar(aCalendar, null);
			}
		},

		// called after the pref is set
		// void onCalendarPrefSet(in calICalendar aCalendar, in AUTF8String aName, in AUTF8String aValue);
		onCalendarPrefSet: function(aCalendar, aName, aValue) {
			mLogger.debug("onCalendarPrefSet : " + UtilsOBM.getCalendarOBMName(aCalendar) + " -> " + aName + " -> " + aValue, false, false);
		},

		// called before the pref is deleted
		// void onCalendarPrefDeleting(in calICalendar aCalendar, in AUTF8String aName);
		onCalendarPrefDeleting: function(aCalendar, aName) {
			mLogger.debug("onCalendarPrefDeleting : " + UtilsOBM.getCalendarOBMName(aCalendar) + " -> " + aName, false, false);
		},

		// called before the pref is changed
		// void onCalendarPrefchanged(in calICalendar aCalendar, in AUTF8String aName);
		onCalendarPrefChanged: function(aCalendar, aName, aValue, aOldValue) {

			mLogger.debug("onCalendarPrefChanged : " + UtilsOBM.getCalendarOBMName(aCalendar) + " -> " + aName + " -> " + aValue + " -> " + aOldValue, false, false);
		}
	};

	var calendarManager = UtilsOBM.getCalendarManager();
	calendarManager.addObserver(calendarManagerObserver);

}

var gAddressBookListener = {
	mContactSynchronizer: new AddressBook_Contact_Synchronizer(),

	// void onItemRemoved(nsISupports parentDir, nsISupports item) /
	onItemRemoved: function(parentDir, item) {
		try {

			/*
		mLogger.debug("MyAbListener::onItemRemoved()", false, false
									 + "\tparentDir: nsIAbDirectory: " + (parentDir instanceof Components.interfaces.nsIAbDirectory), false, false
									 + "\t           nsIAbCard: " + (parentDir instanceof Components.interfaces.nsIAbCard), false, false
									 + "\titem: nsIAbDirectory: " + (item instanceof Components.interfaces.nsIAbDirectory), false, false
									 + "\t      nsIAbCard: " + (item instanceof Components.interfaces.nsIAbCard) +"\n");
									 */

			if (item instanceof Components.interfaces.nsIAbCard) {
				var card = item.QueryInterface(Components.interfaces.nsIAbCard);
				if (card.isMailList) {
					return;
				}
				var directory = parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
				this.mContactSynchronizer.notifyItemDeleted(directory, card);

			} else if (item instanceof Components.interfaces.nsIAbDirectory) {
				var directory = item.QueryInterface(Components.interfaces.nsIAbDirectory);
				this.mContactSynchronizer.notifyContainerDeleted(directory);
			}

		} catch(e) {
			mLogger.error("MyAbListener::onItemRemoved()" + e, true, false);
		}
	},

	//- void onItemAdded(nsISupports parentDir, nsISupports item) 
	onItemAdded: function(parentDir, item) {
		try {

			mLogger.debug("MyAbListener::onItemAdded()", false, false);

			if (item instanceof Components.interfaces.nsIAbCard) {
				var card = item.QueryInterface(Components.interfaces.nsIAbCard);
				if (card.isMailList) {
					return;
				}

				var directory = parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);

				this.mContactSynchronizer.notifyItemAdded(directory, card);
			}
		} catch(e) {
			mLogger.error("MyAbListener::onItemAdded()" + e, true, false);
		}
	},

	//-void onItemPropertyChanged(nsISupports item, char* property,
	//-                              PRUnichar* oldValue, PRUnichar* newValue) 
	onItemPropertyChanged: function(item, property, oldValue, newValue) {
		try {

			mLogger.debug("MyAbListener::onItemPropertyChanged():" + "item: " + item + ", property: " + property + ", " + "oldValue: " + oldValue + ", newValue: " + newValue, false, false);

			if (item instanceof Components.interfaces.nsIAbCard) {
				var card = item.QueryInterface(Components.interfaces.nsIAbCard);
				if (card.isMailList) {
					return;
				}
				// does it belong to OBM address books ?
				// TODO. OBM_NEW_AD_MANAGER. use the enumerator obmIAddressBooksManager::getObmAddressBooks instead
				// TODO. this big loop can be reduced to about 15 lines
				for each(var addressBookName in OBM_GetAddressBookNames()) {
					if (addressBookName == "users") {
						//Users are readonly do not notify
						continue;
					}
					if (!Components.classes["@mozilla.org/abmanager;1"]) {
						var abDatabase;
						var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
						var addressBookService = Components.classes["@mozilla.org/addressbook;1"].getService(Components.interfaces.nsIAddressBook);
						var abURI = "moz-abmdbdirectory://alia-obm-" + addressBookName + ".mab";
						try {
							abDatabase = addressBookService.getAbDatabaseFromURI(abURI);
						} catch(e) {
							continue;
						}
						if (abDatabase.containsCard(card)) {
							var directory = rdfService.GetResource(abURI).QueryInterface(Components.interfaces.nsIAbDirectory);
							if (!directory) {
								continue;
							}
							var item = null;
							try {
								var obmId = card.anniversaryDay;
								item = abDatabase.getCardFromAttribute(directory, "AnniversaryDay", obmId, false);
							} catch(e) {
								continue;
							}
							if (!item) {
								continue;
							}
							this.mContactSynchronizer.notifyItemModified(directory, card);
							return;
						}
					} else {
						var addressBookManager = Components.classes["@mozilla.org/abmanager;1"].getService(Components.interfaces.nsIAbManager);
						var dirName = "ldap_2.servers." + addressBookName;
						var iter = addressBookManager.directories;
						while (iter.hasMoreElements()) {
							var data = iter.getNext();
							if (data instanceof Components.interfaces.nsIAbDirectory) {
								if (data.dirPrefId == dirName) {
									var directory = data;
								}
							}
						}
						try {
							var obmId = card.getProperty("ObmId", false);
							if (directory && directory.hasCard(card) && directory.getCardFromProperty("ObmId", obmId, false)) {
								this.mContactSynchronizer.notifyItemModified(directory, card);
								return;
							}
						} catch(e) {
							continue;
						}
					}
				}
			}
		} catch(e) {
			mLogger.error("MyAbListener::onItemPropertyChanged()" + e, true, false);
		}
	}
};

function OBM_RegisterAddressBookListener() {
	//-    Address Book listener events:
	//-     - An address book, mailing list or card is added
	//-     - A mailing list or card is removed from an address book
	//-     - An address book is removed
	//-     - An address book, mailing list or card is changed
	if ("@mozilla.org/abmanager;1" in Components.classes) {
		var addressBookSession = Components.classes["@mozilla.org/abmanager;1"].getService(Components.interfaces.nsIAbManager);
		addressBookSession.addAddressBookListener(gAddressBookListener, Components.interfaces.nsIAbListener.all);
	} else {
		var addressBookSession = Components.classes["@mozilla.org/addressbook/services/session;1"].getService(Components.interfaces.nsIAddrBookSession);
		addressBookSession.addAddressBookListener(gAddressBookListener, Components.interfaces.nsIAddrBookSession.all);
	}
}

function OBM_UnRegisterAddressBookListener() {
	//-    Address Book listener events:
	//-     - An address book, mailing list or card is added
	//-     - A mailing list or card is removed from an address book
	//-     - An address book is removed
	//-     - An address book, mailing list or card is changed
	if ("@mozilla.org/abmanager;1" in Components.classes) {
		var addressBookSession = Components.classes["@mozilla.org/abmanager;1"].getService(Components.interfaces.nsIAbManager);
		addressBookSession.removeAddressBookListener(gAddressBookListener);
	} else {
		var addressBookSession = Components.classes["@mozilla.org/addressbook/services/session;1"].getService(Components.interfaces.nsIAddrBookSession);
		addressBookSession.removeAddressBookListener(gAddressBookListener);
	}
}

var freeBusyProvider = {
	// 
	// calIFreeBusyProvider
	//
	// calIOperation getFreeBusyIntervals(in AUTF8String aCalId,
	//                                    in calIDateTime aRangeStart,
	//                                    in calIDateTime aRangeEnd,
	//                                    in unsigned long aBusyTypes,
	//                                    in calIGenericOperationListener aListener);
	getFreeBusyIntervals: function(aCalId, aRangeStart, aRangeEnd, aBusyTypes, aListener) {
		if (aCalId.indexOf("MAILTO:") != 0) {
			return;
		}

		var operation = {
			id: Date.now(),
			isPending: true,
			status: Components.results.NS_OK,
			success: false,
			cancel: function(aStatus) {
				this.status = aStatus;
			}
		};

		var url = UtilsOBM.getCharPref("extensions.obm.server");
		url = url.replace("services", "freebusy");
		url += "/" + aCalId.split("MAILTO:")[1];

		var xmlHttpRequest = new XMLHttpRequest();

		xmlHttpRequest.open("GET", url, true);
		xmlHttpRequest.onreadystatechange = function(event) {
			if (xmlHttpRequest.readyState == 4) {
				if (xmlHttpRequest.status == 200) {
					try {
						//mLogger.debug("freebusy:\n" + xmlHttpRequest.responseText, false, false);
						var freeBusyEntries = xmlHttpRequest.responseText.match(/FREEBUSY.+/g);
						var freeBusyIntervals = [];

						if (freeBusyEntries) {
							for (var i = 0; i < freeBusyEntries.length; i++) {
								var dates = freeBusyEntries[i].split(/FREEBUSY(;FBTYPE=BUSY)?:/)[2].split("/");
								if (dates.length != 2) {
									continue;
								}

								var startDate = Components.classes["@mozilla.org/calendar/datetime;1"].createInstance(Components.interfaces.calIDateTime);
								startDate.icalString = dates[0];
								var endDate = Components.classes["@mozilla.org/calendar/datetime;1"].createInstance(Components.interfaces.calIDateTime);
								endDate.icalString = dates[1];

								var timeInterval = Components.classes["@mozilla.org/calendar/period;1"].createInstance(Components.interfaces.calIPeriod);
								timeInterval.start = startDate;
								timeInterval.end = endDate;

								var interval = {
									calId: aCalId,
									interval: timeInterval,
									freeBusyType: Components.interfaces.calIFreeBusyInterval.BUSY
								};
								freeBusyIntervals.push(interval);
							}
						}
						operation.success = true;
					} catch(e) {
						operation.success = false;
						operation.status = Components.results.NS_ERROR_FAILED;
						freeBusyIntervals = null;
					}

					operation.isPending = false;
					aListener.onResult(operation, freeBusyIntervals);
				}
			}
		};

		xmlHttpRequest.send(null);
	}
};

function OBM_RegisterFreeBusyProvider() {
	var freeBusyService = Components.classes["@mozilla.org/calendar/freebusy-service;1"].getService(Components.interfaces.calIFreeBusyService);
	freeBusyService.addProvider(freeBusyProvider);
}

// Check "reset now" pref is set to true
// (Adding it into a closure to be able to delay it of 5s)
setTimeout(function() {
	if (UtilsOBM.getBoolPref("extensions.obm.resetonstartup", false)) {
		mLogger.notice("Reset on startup asked by preference: extensions.obm.resetonstartup", false, false);
		UtilsOBM.setBoolPref("extensions.obm.resetonstartup", false)
		UtilsOBM.reset();
	} else {
		mLogger.notice("Preference 'extensions.obm.resetonstartup' not set: no reset asked", false, false);
	}
}, 5000);

var infos = UtilsOBM.detectVersion();
// Thunderbird
if (Components.interfaces.nsIAbDirectory) {
	OBM_RegisterAddressBookListener();
}
if (Components.interfaces.calIFreeBusyService) { // Lightning 0.7+
	OBM_RegisterFreeBusyProvider();
}
if (Components.interfaces.calICalendar) {
	OBM_RegisterCalendarManagerObserver();
}

//reset pref after a reset
UtilsOBM.setSyncOnQuitAfterReset();
UtilsOBM.setSyncOnStartAfterReset();

//add buttons
function OBM_InitToolbar() {
	var mainButtonAdded = false;
	var buttonList = ["calendar-obm-sync-button", "calendar-obm-web-button", "calendar-obm-account-button"];
	if (infos.version.indexOf("1.5") == 0) {
		mainButtonAdded = UtilsOBM.addToolbarButton("mail:3pane", "mail-bar", "chrome://messenger/content/messenger.xul#mail-bar", buttonList, "throbber-box");
	}
	if (infos.version.indexOf("2.0") == 0) {
		mainButtonAdded = UtilsOBM.addToolbarButton("mail:3pane", "mail-bar2", "chrome://messenger/content/messenger.xul#mail-bar2", buttonList, "search-container");
	}
	if (infos.version.indexOf("3.") == 0) {
		mainButtonAdded = UtilsOBM.addToolbarButton("mail:3pane", "mail-bar3", "chrome://messenger/content/messenger.xul#mail-bar3", buttonList, "gloda-search");
	}
	return mainButtonAdded;
}

if (!OBM_InitToolbar()) {
	window.addEventListener("load", OBM_InitToolbar, false);
}

// autoconf : subscribe to calendar and remove lightning default calendar
var autoconfedLogin = UtilsOBM.getCharPref("extensions.obm.autoconf.login", null);
if (autoconfedLogin) {
	if (!UtilsOBM.getOBMCredentials({},
	{})) {
		UtilsOBM.setOBMCredentials(autoconfedLogin, "");
		mLogger.debug("login intialized with autconfed login " + autconfedlogin, false, false);
	}
}
